--- org/postgresql/ds/common/BaseDataSource.java.orig	2009-06-20 18:19:40.000000000 +0300
+++ org/postgresql/ds/common/BaseDataSource.java	2010-03-03 11:44:38.000000000 +0200
@@ -55,6 +55,7 @@
     private String sslfactory;
     private boolean tcpKeepAlive = false;
     private String compatible;
+    private String loglevel;
 
     /**
      * Gets a connection to the PostgreSQL database.  The database is identified by the
@@ -168,6 +169,16 @@
         this.compatible = compatible;
     }
 
+    public String getLoglevel()
+    {
+        return loglevel;
+    }
+
+    public void setLoglevel(String compatible)
+    {
+        this.loglevel = loglevel;
+    }
+
     /**
      * Gets the name of the PostgreSQL database, running on the server identified
      * by the serverName property.
@@ -380,6 +391,9 @@
         if (compatible != null) {
             sb.append("&compatible="+compatible);
         }
+        if (loglevel != null) {
+            sb.append("&loglevel="+loglevel);
+        }
 
         return sb.toString();
     }
@@ -425,6 +439,10 @@
         {
             ref.add(new StringRefAddr("compatible", compatible));
         }
+        if (loglevel != null)
+        {
+            ref.add(new StringRefAddr("loglevel", loglevel));
+        }
 
         return ref;
     }
@@ -444,6 +462,7 @@
         out.writeObject(sslfactory);
         out.writeBoolean(tcpKeepAlive);
         out.writeObject(compatible);
+        out.writeObject(loglevel);
     }
 
     protected void readBaseObject(ObjectInputStream in) throws IOException, ClassNotFoundException
@@ -461,6 +480,7 @@
         sslfactory = (String)in.readObject();
         tcpKeepAlive = in.readBoolean();
         compatible = (String)in.readObject();
+        loglevel = (String)in.readObject();
     }
 
 }
